#!/bin/bash

CS_HOST_PORT="localhost:8080"
PROCESSED_DIR=/opt/cashserver
PROCESSED_ARCHIVE_DIR=/opt/backup
FILES_UPTIME=30

echo "date: $(date): begin backup..."

for directory in broken error processed; do
    echo "work with $directory"
    access_rule="$(stat -c%a $PROCESSED_DIR/$directory)"
    owner_rule="$(stat -c'%g:%G' $PROCESSED_DIR/$directory)"
    echo "access: $access_rule"
    echo "rule: $owner_rule"
    tar --remove-files -c $PROCESSED_DIR/$directory/ | gzip >  $PROCESSED_ARCHIVE_DIR/$(echo $directory)_archive/file-$(date +%y-%m-%d).tgz
    if [[ ! -d "$PROCESSED_DIR/$directory/" ]]; then
	echo "restore directory $directory"
	mkdir $PROCESSED_DIR/$directory
	chmod $access_rule $PROCESSED_DIR/$directory
	chown $owner_rule $PROCESSED_DIR/$directory
    fi;
#    zip -rm $PROCESSED_ARCHIVE_DIR/$(echo $directory)_archive/file-$(date +%d-%m-%y) $PROCESSED_DIR/$directory/*
    find $PROCESSED_ARCHIVE_DIR/$(echo $directory)_archive -mtime +$FILES_UPTIME -delete
done;

# remove archive dicts
dicts_dir=$(curl -s http://${CS_HOST_PORT}/CSrest/rest/propertys/SEND_DICTS_ON_CASHES_BY_URL_LOCAL_DIRECTORY | jq --raw-output '.value')
if [ ! -z $dicts_dir ]; then
    archive_dicts_dir=$dicts_dir/archive
    echo "clear ${archive_dicts_dir}"
    rm -rf $archive_dicts_dir/*
fi


echo "date: $(date): end backup..."
